package ru.lifepay.checkout.demo.data

import android.content.Context
import android.content.SharedPreferences
import com.google.gson.Gson

object LifepaySpecificDataRepository {

    private var preferences: SharedPreferences? = null

    fun setContext(context: Context) {
        if (preferences == null) {
            preferences = context.applicationContext.getSharedPreferences(
                "LifepaySpecificDataRepository",
                Context.MODE_PRIVATE
            )
        }
    }

    fun getData(): LifepaySpecificData {
        val json = preferences?.getString("data", null)
        if (json == null) {
            val data = LifepaySpecificData()
            save(data)
            return data
        }
        return Gson().fromJson(json, LifepaySpecificData::class.java)
    }

    fun save(data: LifepaySpecificData) {
        val reportsJson = Gson().toJson(data)
        preferences?.edit()?.putString("data", reportsJson)?.apply()
    }
}