package ru.lifepay.checkout.demo.periphery

import android.app.Activity
import android.content.ActivityNotFoundException
import android.content.Intent
import ru.lifepay.checkout.demo.Actions
import ru.lifepay.checkout.demo.util.Logger

class PRRequest(val activity: Activity, val errorCallback: (message: String?) -> Unit) {

    /**
     * Открыть экран подключения оборудования
     */
    fun manageConnectedDevices() {
        sendRequest(
            intent = Intent(Actions.PR_MANAGE_CONNECTED_DEVICES)
        )
    }

    private fun sendRequest(intent: Intent) {
        Logger.logRequest(intent)
        try {
            activity.startActivityForResult(intent, 5555) //число 5555 взято просто так, можно использовать другое число.
        } catch (e: ActivityNotFoundException) {
            errorCallback.invoke("Приложение LIFE POS Checkout не установлено на устройстве. Необходимо установить приложение.")
        } catch (e: Throwable) {
            errorCallback.invoke(e.message)
        }
    }
}