package ru.lifepay.checkout.demo.quickpaymentsterminal

import ru.lifepay.common.extensions.GSONConverter
import ru.lifepay.periphery.models.quickpayments.QPTransaction
import java.util.*

/**
 * Данные для оплаты через СБП
 */
class QPOrder(
    //Сумма транзакции в копейках
    val amount: Long
    ) {

    var refundTransactionRequestId: String
        private set

    init {
        refundTransactionRequestId = createRequestId()
    }

    private var paymentTransactionJson: String? = null

    val paymentTransaction: QPTransaction?
        get() = paymentTransactionJson?.let {
            GSONConverter.fromJSON(it, QPTransaction::class.java)
        }

    private var refundTransactionJson: String? = null

    val refundTransaction: QPTransaction?
        get() = refundTransactionJson?.let {
            GSONConverter.fromJSON(it, QPTransaction::class.java)
        }


    fun updateRefundTransactionRequestId() {
        refundTransactionRequestId = createRequestId()
    }

    fun setPaymentTransaction(transaction: QPTransaction) {
        this.paymentTransactionJson = transaction.toJSON()
    }

    fun setRefundTransaction(transaction: QPTransaction) {
        this.refundTransactionJson = transaction.toJSON()
    }

    private fun createRequestId(): String {
        return UUID.randomUUID().toString()
    }
}