package ru.lifepay.checkout.demo.ui

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import kotlinx.android.synthetic.main.activity_main.*
import ru.lifepay.checkout.demo.R
import ru.lifepay.checkout.demo.data.LifepaySpecificDataRepository
import ru.lifepay.checkout.demo.util.Util

class MainActivity : AppCompatActivity() {

    @SuppressLint("SourceLockedOrientationActivity", "SetTextI18n")
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
//        requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
        setContentView(R.layout.activity_main)
        activationScreenButton.setOnClickListener {
            val launchIntent = Intent()
            launchIntent.setClass(this, ActivationActivity::class.java)
            startActivity(launchIntent)
        }

        transactionButton.setOnClickListener {
            val launchIntent = Intent()
            launchIntent.setClass(this, PaymentTerminalActivity::class.java)
            startActivity(launchIntent)
        }

        qpTransactionButton.setOnClickListener {
            val launchIntent = Intent()
            launchIntent.setClass(this, QuickPaymentsTerminalActivity::class.java)
            startActivity(launchIntent)
        }

        reportsButton.setOnClickListener {
            val launchIntent = Intent()
            launchIntent.setClass(this, ReportsActivity::class.java)
            startActivity(launchIntent)
        }

        peripheryButton.setOnClickListener {
            val launchIntent = Intent()
            launchIntent.setClass(this, PeripheryActivity::class.java)
            startActivity(launchIntent)
        }

        settingsButton.setOnClickListener {
            val launchIntent = Intent()
            launchIntent.setClass(this, ParametersActivity::class.java)
            startActivity(launchIntent)
        }

        versionTextView.text = "v${Util.getAppVersion(this)}"
        LifepaySpecificDataRepository.setContext(this)
    }

    override fun onResume() {
        super.onResume()

        val lifepaySpecificData = LifepaySpecificDataRepository.getData()
        var helpText = ""
        if (lifepaySpecificData.login.isNullOrBlank() || lifepaySpecificData.password.isNullOrBlank()) {
            helpText += "login/password для платежного терминала Lifepay QPOS не заданы\n"
        }
        if (helpText.isNotEmpty()) {
            helpText += "Чтобы заполнить необходимые данные перейдите на экран параметров."
        }
        settingsHelpTextView.text = helpText
    }
}
