package ru.lifepay.checkout.demo.util

import android.app.Activity
import android.content.Context
import android.content.pm.PackageManager
import android.view.View
import android.view.inputmethod.InputMethodManager
import androidx.appcompat.app.AlertDialog

object Util {

    fun showError(context: Context, text: String) {
        showErrorCallback(context).invoke(text)
    }

    fun showErrorCallback(context: Context): (String?) -> Unit = { text ->
        val builder = AlertDialog.Builder(context)
        builder.setTitle("Ошибка")
            .setMessage(text)
            .setCancelable(true)
        val alert = builder.create()
        alert.show()
    }

    fun hideKeyboard(context: Context, view: View) {
        val imm = context.getSystemService(Activity.INPUT_METHOD_SERVICE) as InputMethodManager
        imm.hideSoftInputFromWindow(view.windowToken, 0)
    }

    fun getAppVersion(context: Context): String {
        try {
            val pInfo = context.getPackageManager().getPackageInfo(context.getPackageName(), 0)
            return pInfo.versionName ?: "неизвестная"
        } catch (e: PackageManager.NameNotFoundException) {
            return "неизвестная"
        }
    }
}